<template>
    <div class="eliminar">
        <!--Formulario de búsqueda--> 
        <div class="container">
            <div class="row">
                <div class="h2 titulo"> {{ titulo }} </div>
            </div>

            <!--Botones de  búsqueda-->
                <div class="row">
                    <div class="btn-group btn-group-toggle" data-toggle="buttons">
                        <button type="button" class="btn btn-info" @click="formSucursal">
                            <input type="radio" name="options" id="option1" v-model="selectSucursal"> Sucursal
                        </button>
                        <button type="button" class="btn btn-info" @click="formRegional">
                            <input type="radio" name="options" id="option1" v-model="selectRegional"> Regional
                        </button>
                    </div>
                </div>

                <!--Formulario de búsqueda por sucursal-->
                    <form v-if="selectSucursal === true">
                    <div class="form-row mt-3">
                        <div class="form-group col-md-6">
                            <label for="fecha_1">Fecha Inicio: </label>
                            <input type="date" class="form-control" id="fecha_1" name="fecha_1" v-model="fecha_1"/>
                            <small id="demo" class="form-text text-danger" v-if="!fecha_1">
                            *Campo requerido.
                            </small>
                        </div>
                        <div class="form-group col-md-3">
                            <label for="fecha_2">Fecha fin: </label>
                            <input type="date" class="form-control" id="fecha_2" name="fecha_2" v-model="fecha_2"/>
                            <small id="demo" class="form-text text-danger" v-if="!fecha_2">
                            *Campo requerido.
                            </small>
                        </div>
                        <div class="form-group col-md-3">
                            <label for="sucursal">Sucursal: </label>
                            <select class="custom-select" name="sucursal2" id="sucursal" v-model="sucursal">
                            <option selected></option>
                                <option value="xalapa">Xalapa</option>
                                <option value="teziutlan">Teziutlán</option>
                                <option value="oaxaca">Oaxaca</option>
                                <option value="puebla">Puebla</option>
                                <option value="huamantla">Huamantla</option>
                            </select>
                            <small id="demo" class="form-text text-danger" v-if="!sucursal">
                            *Campo requerido.
                            </small>
                        </div>
                    </div>

                    <button type="button" class="btn btn-primary" @click="buscarPorRangoFechaSucursal">Buscar</button>
                </form>

                <!--Formulario de búsqueda por regional-->
                <form v-if="selectRegional === true">
                    <div class="form-row mt-3">
                        <div class="form-group col-md-6">
                            <label for="fecha_1">Fecha Inicio: </label>
                            <input type="date" class="form-control" id="fecha_1" name="fecha_1" v-model="fecha_1"/>
                            <small id="demo" class="form-text text-danger" v-if="!fecha_1">
                            *Campo requerido.
                            </small>
                        </div>
                        <div class="form-group col-md-3">
                            <label for="fecha_2">Fecha fin: </label>
                            <input type="date" class="form-control" id="fecha_2" name="fecha_2" v-model="fecha_2"/>
                            <small id="demo" class="form-text text-danger" v-if="!fecha_2">
                            *Campo requerido.
                            </small>
                        </div>
                        <div class="form-group col-md-3">
                            <label for="regional">Regional: </label>
                            <select class="custom-select" name="regional" id="regional" v-model="regional">
                                <option selected></option>
                                <option value="veracruz">Veracruz</option>
                                <option value="oaxaca">Oaxaca</option>
                                <option value="puebla">Puebla</option>
                            </select>
                            <small id="demo" class="form-text text-danger" v-if="!regional">
                                *Campo requerido.
                            </small>
                        </div>
                    </div>

                    <button type="button" class="btn btn-primary" @click="buscarPorRangoFechaRegional">Buscar</button>
                </form>
                
            <!--Alerta Delete-->
            <div v-if="isDeleted" class="alert alert-warning alert-dismissible fade show mt-5">
                Eliminado Exitosamente
                <button type="button" class="close" data-dismiss="alert" aria-label="Close" @click="deleteMssg">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>

            <!--Tabla de resultado de búsqueda-->
            <div class="row">
                <div class="table-responsive">
                    <table class="table table-striped header table-hover">
                        <thead>
                            <tr>
                                <th scope="col">ID</th>
                                <th scope="col">Nombre AC</th>
                                <th scope="col">Clientes</th>
                                <th scope="col">Monto</th>
                                <th scope="col">Banco</th>
                                <th scope="col">Fecha desembolso</th>
                                <th scope="col">Sucursal</th>
                                <th scope="col">Regional</th>
                                <th scope="col">Acciones</th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr v-for="item in displayedDesembolsos" :key="item.id">
                                <th>{{ item.id }}</th>
                                <td>{{ item.nombre_ac }}</td>
                                <td>{{ item.clientes }}</td>
                                <td>{{ item.monto }}</td>
                                <td>{{ item.banco }}</td>
                                <td>{{ item.fecha_desembolso }}</td>
                                <td>{{ item.sucursal }}</td>
                                <td>{{ item.regional }}</td>
                                <td>
                                    <div class="btn-group">
                                        <button class="btn btn-outline-danger" @click="deleteDesembolso(item.id)">
                                            <i class="fas fa-trash-alt"></i>
                                        </button>
                                    </div>
                                </td>
                            </tr>
                        </tbody>
                    </table>
                </div>
            </div>

            <!--     Ciclo para mostrar numero de páginas dentro de un array       -->
            <div class="btn-group col-md-2 offset-md-5">

                <button
                    type="button"
                    class="btn btn-sm btn-primary"
                    v-if="page != 1"
                    @click="page--"
                    > Prev. 
                </button>
                <button
                    type="button"
                    class="btn btn-sm btn-primary"
                    v-for="pageNumber in pages.slice(page-1, page+5)"
                    @click="page = pageNumber"
                    :key="pageNumber"
                    >{{pageNumber}}
                </button>
                <button
                    type="button"
                    @click="page++"
                    v-if="page < pages.length"
                    class="btn btn-sm btn-primary"
                    >>>
                </button>

            </div>
        </div>
        
        <!--Footer/Pie de pagina-->
        <Footer></Footer>
    </div>
</template>

<script>
import Footer from './Footer'
import axios from 'axios'

export default {
    name: "Eliminar",
    components: {
        Footer
    },
    data(){
        return{
            titulo: "Eliminar",
            lista: [],
            id: "",
            nombre_ac: "",
            clientes: "",
            monto: "",
            banco: "",
            fecha_desembolso: "",
            sucursal: "",
            regional: "",
            isDeleted: false,
            fecha_1: "",
            fecha_2: "",
            selectSucursal: false,
            selectRegional: false,
            page: 1,
            perPage: 10,
            pages: []
        }
    },
    methods: {
        deleteMssg() {
            this.isDeleted = false;
        },

        setLista() {
            let numberOfPages = Math.ceil(this.lista.length / this.perPage);
            for (let i = 1; i <= numberOfPages; i++) {
                this.pages.push(i);
            }
        },
        paginate(lista) {
            let page = this.page;
            let perPage = this.perPage;
            let from = (page * perPage) - perPage;
            let to = (page * perPage);
            return lista.slice(from, to);
        },

        formSucursal: function(){
            this.selectSucursal = true;
            this.selectRegional = false;
            this.fecha_1 = "";
            this.fecha_2 = "";
            this.sucursal = "";
            this.lista = '';
            this.pages = [];
            this.page = 1;
        },

        formRegional: function(){
            this.selectRegional = true;
            this.selectSucursal = false;
            this.fecha_1 = "";
            this.fecha_2 = "";
            this.regional = "";
            this.lista = '';
            this.pages = [];
            this.page = 1;
        },

        buscarPorRangoFechaSucursal() {
            axios.post('/operaciones/sucursal', {
                fecha_1: this.fecha_1,
                fecha_2: this.fecha_2,
                sucursal: this.sucursal,
            })
            .then((res) => {
                this.lista = res.data;
                this.fecha_1 = this.fecha_1,
                this.fecha_2 = this.fecha_2,
                this.sucursal = this.sucursal,
                console.log(res);
                
            })
            .catch((err) => {
                console.log(err);
            })
        },

        buscarPorRangoFechaRegional() {
            axios.post('/operaciones/regional', {
                fecha_1: this.fecha_1,
                fecha_2: this.fecha_2,
                regional: this.regional,
            })
            .then((res) => {
                this.fecha_1 = this.fecha_1,
                this.fecha_2 = this.fecha_2,
                this.regional = this.regional,
                console.log(this.regional);
                console.log(res);
                this.lista = res.data;
            })
            .catch((err) => {
                console.log(err);
            })
        },

        /*listarDatos() {
            axios
            .get("/operaciones")
            .then((response) => {
                this.lista = response.data;
                //console.log(response)
            })
            .catch((e) => console.log(e));
        },*/

        deleteDesembolso(id) {
            const alerta = confirm("¿Desea eliminar el registro seleccionado?");
            if (alerta == true) {
                axios.delete(`/operaciones/${id}`)
                .then((res) => {
                    this.isDeleted = true;
                    this.fecha_1 = "";
                    this.fecha_2 = "";
                    this.lista =  [];
                    this.selectSucursal = false,
                    this.selectRegional =  false,
                    console.log(res)
                })
                .catch((err) => {
                    console.log(err)
                })
                //console.log(alerta);
            } else {
                console.log('Cancelado');
            }
        }
    },

    watch: {
        lista(){
            this.setLista();
        }
    },
    computed: {
        displayedDesembolsos: function () {
            return this.paginate(this.lista);
        }
    },
}
</script>